/* ********************************************************** */
/*      dspinit.c                                             */
/*          CIN source code to initialize dsp board           */
/*      2001/12/20   T. YOSHIKAWA                             */
/* ********************************************************** */

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <sys/stat.h>
#include <unistd.h>
#include <math.h>
#include "extcode.h"
#include "p6fxioctl.h"
#include "p6fxlib.h"

#define ERRBUF 128	/* error massage buffer size */

/*
 * typedefs
 */

typedef struct {
	int32 dimSize;
	int32 Numeric[1];
	} TD2;
typedef TD2 **TD2Hdl;

typedef struct {
	int32 btotal;
	int32 dtotal;
	TD2Hdl dspfd;
	TD2Hdl bnum;
	TD2Hdl dsptime;
	LStrHandle msg;
	} TD1;

typedef struct {
	LVBoolean status;
	int32 code;
	LStrHandle source;
	} TD3;

CIN MgErr CINRun(TD1 *cblk, LStrHandle loadFile, TD3 *error, uInt32 *TIMEOUT, uInt32 *MAP, uInt32 *boardNo);

CIN MgErr CINRun(TD1 *cblk, LStrHandle loadFile, TD3 *error, uInt32 *TIMEOUT, uInt32 *MAP, uInt32 *boardNo) {
	
	CTLBLK ctlblk;
	int32 i;
	Str255 TmpPStrp;
	uChar loadFileC[ERRBUF];
	
/* resize buffer */
	NumericArrayResize(uB, 1, (UHandle*)&(error->source), ERRBUF);
	LStrLen(*(error->source)) = ERRBUF;
	NumericArrayResize(iL, 1, (UHandle*)&(cblk->dspfd), MAX_DSP);
	(*(cblk->dspfd))->dimSize = MAX_DSP;
	NumericArrayResize(iL, 1, (UHandle*)&(cblk->bnum), MAX_DSP);
	(*(cblk->bnum))->dimSize = MAX_DSP;
	NumericArrayResize(iL, 1, (UHandle*)&(cblk->dsptime), MAX_DSP);
	(*(cblk->dsptime))->dimSize = MAX_DSP;
	NumericArrayResize(uB, 1, (UHandle*)&(cblk->msg), ERRBUF);
	LStrLen(*(cblk->msg)) = ERRBUF;
	
/* copy loadFile to C type String */
	LToPStr(*loadFile, TmpPStrp);
	PToCStr(TmpPStrp, loadFileC);
	
/* initialize dsp board */
	if (p6x_open(&ctlblk)) {
		error->status = LVTRUE;
		CToPStr(ctlblk.msg, TmpPStrp);
		PToLStr(TmpPStrp, *(error->source));
		goto end;
	}

	p6x_timeout(&ctlblk, *boardNo, *TIMEOUT);

	if (p6x_del(&ctlblk, *boardNo, *MAP)) {
		error->status = LVTRUE;
		CToPStr(ctlblk.msg, TmpPStrp);
		PToLStr(TmpPStrp, *(error->source));
		goto end;
	}
	
	if (p6x_load(&ctlblk, *boardNo, loadFileC)) {
		error->status = LVTRUE;
		CToPStr(ctlblk.msg, TmpPStrp);
		PToLStr(TmpPStrp, *(error->source));
		goto end;
	}

	if (p6x_start(&ctlblk, *boardNo)) {
		error->status = LVTRUE;
		CToPStr(ctlblk.msg, TmpPStrp);
		PToLStr(TmpPStrp, *(error->source));
		goto end;
	}
	
	end: ;	
	
/* return control block */
	
	cblk->btotal = ctlblk.btotal;
	cblk->dtotal = ctlblk.dtotal;
	for(i=0; i<MAX_DSP; i++)
		(*(cblk->dspfd))->Numeric[i] = ctlblk.dspfd[i];
	for(i=0; i<MAX_DSP; i++)
		(*(cblk->bnum))->Numeric[i] = ctlblk.bnum[i];
	for(i=0; i<MAX_DSP; i++)
		(*(cblk->dsptime))->Numeric[i] = ctlblk.dsptime[i];
	CToPStr(ctlblk.msg, TmpPStrp);
	PToLStr(TmpPStrp, *(cblk->msg));
	
	return noErr;
	}
