/*
 * CIN source file 
 */

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <sys/stat.h>
#include <unistd.h>
#include <math.h>
#include "p6fxioctl.h"
#include "p6fxlib.h"
#include "extcode.h"

#define ERRBUF 128	/* error massage buffer size */

/*
 * typedefs
 */

typedef struct {
	int32 dimSize;
	int32 Numeric[1];
	} TD2;
typedef TD2 **TD2Hdl;

typedef struct {
	int32 btotal;
	int32 dtotal;
	TD2Hdl dspfd;
	TD2Hdl bnum;
	TD2Hdl dsptime;
	LStrHandle msg;
	} TD1;

typedef struct {
	LVBoolean status;
	int32 code;
	LStrHandle source;
	} TD3;

typedef struct {
	int32 dimSize;
	uInt32 Numeric[1];
	} TD4;
typedef TD4 **TD4Hdl;

CIN MgErr CINRun(TD1 *cblk, uInt32 *boardNo, TD4Hdl argment, TD3 *error);

CIN MgErr CINRun(TD1 *cblk, uInt32 *boardNo, TD4Hdl argment, TD3 *error) {
	CTLBLK ctlblk;
	Str255 TmpPStrp;
	int32 i;
	
/* get control block */
	ctlblk.btotal = cblk->btotal;
	ctlblk.dtotal = cblk->dtotal;
	for(i=0; i<MAX_DSP; i++)
		ctlblk.dspfd[i] = (*(cblk->dspfd))->Numeric[i];
	for(i=0; i<MAX_DSP; i++)
		ctlblk.bnum[i] = (*(cblk->bnum))->Numeric[i];
	for(i=0; i<MAX_DSP; i++)
		ctlblk.dsptime[i] = (*(cblk->dsptime))->Numeric[i];
	LToPStr(*(cblk->msg), TmpPStrp);
	PToCStr(TmpPStrp, ctlblk.msg);
	
/* start dsp */
	p6x_write(&ctlblk, *boardNo, (*argment)->Numeric, (*argment)->dimSize);
	
/* return control block */
	
	cblk->btotal = ctlblk.btotal;
	cblk->dtotal = ctlblk.dtotal;
	for(i=0; i<MAX_DSP; i++)
		(*(cblk->dspfd))->Numeric[i] = ctlblk.dspfd[i];
	for(i=0; i<MAX_DSP; i++)
		(*(cblk->bnum))->Numeric[i] = ctlblk.bnum[i];
	for(i=0; i<MAX_DSP; i++)
		(*(cblk->dsptime))->Numeric[i] = ctlblk.dsptime[i];
	CToPStr(ctlblk.msg, TmpPStrp);
	PToLStr(TmpPStrp, *(cblk->msg));
	
	return noErr;
	}
